pragma Ada_95;
pragma Warnings (Off);
pragma Source_File_Name (ada_main, Spec_File_Name => "b__try_unix.ads");
pragma Source_File_Name (ada_main, Body_File_Name => "b__try_unix.adb");
pragma Suppress (Overflow_Check);
with Ada.Exceptions;

package body ada_main is

   E013 : Short_Integer; pragma Import (Ada, E013, "system__soft_links_E");
   E023 : Short_Integer; pragma Import (Ada, E023, "system__exception_table_E");
   E025 : Short_Integer; pragma Import (Ada, E025, "system__exceptions_E");
   E017 : Short_Integer; pragma Import (Ada, E017, "system__secondary_stack_E");
   E084 : Short_Integer; pragma Import (Ada, E084, "ada__containers_E");
   E091 : Short_Integer; pragma Import (Ada, E091, "ada__io_exceptions_E");
   E104 : Short_Integer; pragma Import (Ada, E104, "ada__strings_E");
   E066 : Short_Integer; pragma Import (Ada, E066, "interfaces__c_E");
   E153 : Short_Integer; pragma Import (Ada, E153, "interfaces__c__strings_E");
   E144 : Short_Integer; pragma Import (Ada, E144, "system__os_lib_E");
   E005 : Short_Integer; pragma Import (Ada, E005, "ada__tags_E");
   E090 : Short_Integer; pragma Import (Ada, E090, "ada__streams_E");
   E147 : Short_Integer; pragma Import (Ada, E147, "system__file_control_block_E");
   E093 : Short_Integer; pragma Import (Ada, E093, "system__finalization_root_E");
   E088 : Short_Integer; pragma Import (Ada, E088, "ada__finalization_E");
   E140 : Short_Integer; pragma Import (Ada, E140, "system__file_io_E");
   E170 : Short_Integer; pragma Import (Ada, E170, "ada__streams__stream_io_E");
   E131 : Short_Integer; pragma Import (Ada, E131, "system__storage_pools_E");
   E125 : Short_Integer; pragma Import (Ada, E125, "system__finalization_masters_E");
   E123 : Short_Integer; pragma Import (Ada, E123, "system__storage_pools__subpools_E");
   E064 : Short_Integer; pragma Import (Ada, E064, "ada__calendar_E");
   E072 : Short_Integer; pragma Import (Ada, E072, "ada__calendar__time_zones_E");
   E174 : Short_Integer; pragma Import (Ada, E174, "ada__text_io_E");
   E106 : Short_Integer; pragma Import (Ada, E106, "ada__strings__maps_E");
   E109 : Short_Integer; pragma Import (Ada, E109, "ada__strings__maps__constants_E");
   E117 : Short_Integer; pragma Import (Ada, E117, "ada__strings__unbounded_E");
   E164 : Short_Integer; pragma Import (Ada, E164, "system__pool_global_E");
   E149 : Short_Integer; pragma Import (Ada, E149, "system__regexp_E");
   E099 : Short_Integer; pragma Import (Ada, E099, "ada__directories_E");
   E176 : Short_Integer; pragma Import (Ada, E176, "common_E");
   E155 : Short_Integer; pragma Import (Ada, E155, "equal_case_insensitive_E");
   E157 : Short_Integer; pragma Import (Ada, E157, "hash_case_insensitive_E");
   E062 : Short_Integer; pragma Import (Ada, E062, "os_E");

   Local_Priority_Specific_Dispatching : constant String := "";
   Local_Interrupt_States : constant String := "";

   Is_Elaborated : Boolean := False;

   procedure finalize_library is
   begin
      declare
         procedure F1;
         pragma Import (Ada, F1, "os__finalize_body");
      begin
         E062 := E062 - 1;
         F1;
      end;
      E176 := E176 - 1;
      declare
         procedure F2;
         pragma Import (Ada, F2, "common__finalize_spec");
      begin
         F2;
      end;
      E099 := E099 - 1;
      declare
         procedure F3;
         pragma Import (Ada, F3, "ada__directories__finalize_spec");
      begin
         F3;
      end;
      E149 := E149 - 1;
      declare
         procedure F4;
         pragma Import (Ada, F4, "system__regexp__finalize_spec");
      begin
         F4;
      end;
      E164 := E164 - 1;
      declare
         procedure F5;
         pragma Import (Ada, F5, "system__pool_global__finalize_spec");
      begin
         F5;
      end;
      E117 := E117 - 1;
      declare
         procedure F6;
         pragma Import (Ada, F6, "ada__strings__unbounded__finalize_spec");
      begin
         F6;
      end;
      E174 := E174 - 1;
      declare
         procedure F7;
         pragma Import (Ada, F7, "ada__text_io__finalize_spec");
      begin
         F7;
      end;
      E123 := E123 - 1;
      declare
         procedure F8;
         pragma Import (Ada, F8, "system__storage_pools__subpools__finalize_spec");
      begin
         F8;
      end;
      E125 := E125 - 1;
      declare
         procedure F9;
         pragma Import (Ada, F9, "system__finalization_masters__finalize_spec");
      begin
         F9;
      end;
      E170 := E170 - 1;
      declare
         procedure F10;
         pragma Import (Ada, F10, "ada__streams__stream_io__finalize_spec");
      begin
         F10;
      end;
      declare
         procedure F11;
         pragma Import (Ada, F11, "system__file_io__finalize_body");
      begin
         E140 := E140 - 1;
         F11;
      end;
      declare
         procedure Reraise_Library_Exception_If_Any;
            pragma Import (Ada, Reraise_Library_Exception_If_Any, "__gnat_reraise_library_exception_if_any");
      begin
         Reraise_Library_Exception_If_Any;
      end;
   end finalize_library;

   procedure adafinal is
      procedure s_stalib_adafinal;
      pragma Import (C, s_stalib_adafinal, "system__standard_library__adafinal");

      procedure Runtime_Finalize;
      pragma Import (C, Runtime_Finalize, "__gnat_runtime_finalize");

   begin
      if not Is_Elaborated then
         return;
      end if;
      Is_Elaborated := False;
      Runtime_Finalize;
      s_stalib_adafinal;
   end adafinal;

   type No_Param_Proc is access procedure;

   procedure adainit is
      Main_Priority : Integer;
      pragma Import (C, Main_Priority, "__gl_main_priority");
      Time_Slice_Value : Integer;
      pragma Import (C, Time_Slice_Value, "__gl_time_slice_val");
      WC_Encoding : Character;
      pragma Import (C, WC_Encoding, "__gl_wc_encoding");
      Locking_Policy : Character;
      pragma Import (C, Locking_Policy, "__gl_locking_policy");
      Queuing_Policy : Character;
      pragma Import (C, Queuing_Policy, "__gl_queuing_policy");
      Task_Dispatching_Policy : Character;
      pragma Import (C, Task_Dispatching_Policy, "__gl_task_dispatching_policy");
      Priority_Specific_Dispatching : System.Address;
      pragma Import (C, Priority_Specific_Dispatching, "__gl_priority_specific_dispatching");
      Num_Specific_Dispatching : Integer;
      pragma Import (C, Num_Specific_Dispatching, "__gl_num_specific_dispatching");
      Main_CPU : Integer;
      pragma Import (C, Main_CPU, "__gl_main_cpu");
      Interrupt_States : System.Address;
      pragma Import (C, Interrupt_States, "__gl_interrupt_states");
      Num_Interrupt_States : Integer;
      pragma Import (C, Num_Interrupt_States, "__gl_num_interrupt_states");
      Unreserve_All_Interrupts : Integer;
      pragma Import (C, Unreserve_All_Interrupts, "__gl_unreserve_all_interrupts");
      Detect_Blocking : Integer;
      pragma Import (C, Detect_Blocking, "__gl_detect_blocking");
      Default_Stack_Size : Integer;
      pragma Import (C, Default_Stack_Size, "__gl_default_stack_size");
      Leap_Seconds_Support : Integer;
      pragma Import (C, Leap_Seconds_Support, "__gl_leap_seconds_support");
      Bind_Env_Addr : System.Address;
      pragma Import (C, Bind_Env_Addr, "__gl_bind_env_addr");

      procedure Runtime_Initialize (Install_Handler : Integer);
      pragma Import (C, Runtime_Initialize, "__gnat_runtime_initialize");

      Finalize_Library_Objects : No_Param_Proc;
      pragma Import (C, Finalize_Library_Objects, "__gnat_finalize_library_objects");
   begin
      if Is_Elaborated then
         return;
      end if;
      Is_Elaborated := True;
      Main_Priority := -1;
      Time_Slice_Value := -1;
      WC_Encoding := 'b';
      Locking_Policy := ' ';
      Queuing_Policy := ' ';
      Task_Dispatching_Policy := ' ';
      Priority_Specific_Dispatching :=
        Local_Priority_Specific_Dispatching'Address;
      Num_Specific_Dispatching := 0;
      Main_CPU := -1;
      Interrupt_States := Local_Interrupt_States'Address;
      Num_Interrupt_States := 0;
      Unreserve_All_Interrupts := 0;
      Detect_Blocking := 0;
      Default_Stack_Size := -1;
      Leap_Seconds_Support := 0;

      Runtime_Initialize (1);

      Finalize_Library_Objects := finalize_library'access;

      System.Soft_Links'Elab_Spec;
      System.Exception_Table'Elab_Body;
      E023 := E023 + 1;
      System.Exceptions'Elab_Spec;
      E025 := E025 + 1;
      System.Soft_Links'Elab_Body;
      E013 := E013 + 1;
      System.Secondary_Stack'Elab_Body;
      E017 := E017 + 1;
      Ada.Containers'Elab_Spec;
      E084 := E084 + 1;
      Ada.Io_Exceptions'Elab_Spec;
      E091 := E091 + 1;
      Ada.Strings'Elab_Spec;
      E104 := E104 + 1;
      Interfaces.C'Elab_Spec;
      E066 := E066 + 1;
      Interfaces.C.Strings'Elab_Spec;
      E153 := E153 + 1;
      System.Os_Lib'Elab_Body;
      E144 := E144 + 1;
      Ada.Tags'Elab_Spec;
      Ada.Tags'Elab_Body;
      E005 := E005 + 1;
      Ada.Streams'Elab_Spec;
      E090 := E090 + 1;
      System.File_Control_Block'Elab_Spec;
      E147 := E147 + 1;
      System.Finalization_Root'Elab_Spec;
      E093 := E093 + 1;
      Ada.Finalization'Elab_Spec;
      E088 := E088 + 1;
      System.File_Io'Elab_Body;
      E140 := E140 + 1;
      Ada.Streams.Stream_Io'Elab_Spec;
      E170 := E170 + 1;
      System.Storage_Pools'Elab_Spec;
      E131 := E131 + 1;
      System.Finalization_Masters'Elab_Spec;
      System.Finalization_Masters'Elab_Body;
      E125 := E125 + 1;
      System.Storage_Pools.Subpools'Elab_Spec;
      E123 := E123 + 1;
      Ada.Calendar'Elab_Spec;
      Ada.Calendar'Elab_Body;
      E064 := E064 + 1;
      Ada.Calendar.Time_Zones'Elab_Spec;
      E072 := E072 + 1;
      Ada.Text_Io'Elab_Spec;
      Ada.Text_Io'Elab_Body;
      E174 := E174 + 1;
      Ada.Strings.Maps'Elab_Spec;
      E106 := E106 + 1;
      Ada.Strings.Maps.Constants'Elab_Spec;
      E109 := E109 + 1;
      Ada.Strings.Unbounded'Elab_Spec;
      E117 := E117 + 1;
      System.Pool_Global'Elab_Spec;
      E164 := E164 + 1;
      System.Regexp'Elab_Spec;
      E149 := E149 + 1;
      Ada.Directories'Elab_Spec;
      Ada.Directories'Elab_Body;
      E099 := E099 + 1;
      Common'Elab_Spec;
      E176 := E176 + 1;
      E155 := E155 + 1;
      E157 := E157 + 1;
      os'elab_body;
      E062 := E062 + 1;
   end adainit;

   procedure Ada_Main_Program;
   pragma Import (Ada, Ada_Main_Program, "_ada_try_unix");

   function main
     (argc : Integer;
      argv : System.Address;
      envp : System.Address)
      return Integer
   is
      procedure Initialize (Addr : System.Address);
      pragma Import (C, Initialize, "__gnat_initialize");

      procedure Finalize;
      pragma Import (C, Finalize, "__gnat_finalize");
      SEH : aliased array (1 .. 2) of Integer;

      Ensure_Reference : aliased System.Address := Ada_Main_Program_Name'Address;
      pragma Volatile (Ensure_Reference);

   begin
      gnat_argc := argc;
      gnat_argv := argv;
      gnat_envp := envp;

      Initialize (SEH'Address);
      adainit;
      Ada_Main_Program;
      adafinal;
      Finalize;
      return (gnat_exit_status);
   end;

--  BEGIN Object file/option list
   --   /build/libtexttools-eb27m1/libtexttools-2.1.0/examples/try_unix.o
   --   -L/build/libtexttools-eb27m1/libtexttools-2.1.0/examples/
   --   -L/build/libtexttools-eb27m1/libtexttools-2.1.0/examples/
   --   -L/build/libtexttools-eb27m1/libtexttools-2.1.0/build-lib-static/
   --   -L/usr/lib/gcc/x86_64-linux-gnu/7/adalib/
   --   -shared
   --   -lgnat-7
--  END Object file/option list   

end ada_main;
